<template>
  <section
    class="dashboard-section dashboard-section-columns lg:flex-grow gap-4"
  >
    <div
      class="grid gap-4 sm:flex flex-nowrap justify-between w-full flex-grow"
    >
      <dashboard-section-title
        title="Projects"
        sub-title="than last year"
        diff="+40%"
      ></dashboard-section-title>

      <div class="flex flex-nowrap items-center justify-items-start">
        <button
          class="px-4 py-2 border border-solid border-gray-300 text-xs font-semibold"
          :class="{ activeTabBtn: item === currentFilter }"
          v-for="item in ['all', 'outline', 'Stores']"
          :key="item"
          @click="filter(item)"
        >
          {{ item.toUpperCase() }}
        </button>
      </div>
    </div>
    <div class="overflow-auto	">
      <div class="project-section grid gap-2">
        <div class="px-4 py-2 flex flex-nowrap items-center justify-between">
          <p
            class="company-title w-2/5 flex flex-nowrap gap-4 items-center justify-start text-xs font-semibold text-gray-500"
          >
            COMPANIES
          </p>
          <p
            class="flex flex-nowrap items-center justify-start w-1/5 text-xs f1ont-semibold text-gray-500"
          >
            MEMBERS
          </p>
          <p class="w-1/6 text-xs font-semibold text-gray-500">
            BUDGET
          </p>
          <p class="grid gap-1 w-1/6 text-xs font-semibold text-gray-500">
            COMPLETION
          </p>
        </div>
        <div
          class="p-4 flex flex-nowrap items-center justify-between border-t border-solid border-gray-300"
          v-for="company in companies"
          :key="company.name"
        >
          <div
            class="company-title w-2/5 flex flex-nowrap gap-4 items-center justify-start"
          >
            <Icon :name="`logo-${company.name}`"></Icon>
            <span class="font-semibold">{{ company.title }}</span>
          </div>
          <div class="flex flex-nowrap items-center justify-start w-1/5">
            <img
              class="w-6 h-6 rounded-full"
              :src="require(`@/assets/img/${img}.jpg`)"
              :alt="img"
              v-for="(img, idx) in company.members"
              :key="idx"
            />
          </div>
          <p class="font-semibold text-gray-500 w-1/6">{{ company.budget }}</p>
          <div class="grid gap-1 w-1/6 items-center justify-items-start">
            <p>{{ company.completion }}</p>
            <span
              class="h-1 w-full"
              :style="getCompletionColor(company.completion)"
            ></span>
          </div>
        </div>
      </div>
    </div>
    <button
      class="flex items-center justify-center h-16 w-full border-2 border-dashed border-gray-300 outline-none text-gray-500"
    >
      Upload New Projects
    </button>
  </section>
</template>

<script lang="ts">
import Vue from "vue";

export default Vue.extend({
  data() {
    return {
      currentFilter: "all",
      companies: [
        {
          name: "shopify",
          title: "Soft UI Shopify Version",
          members: ["face-1", "face-2", "face-3", "face-4"],
          budget: "$14,000",
          completion: 60
        },
        {
          name: "atlassian",
          title: "Progress Track",
          members: ["face-3", "face-4"],
          budget: "$3,000",
          completion: 10
        },
        {
          name: "slack",
          title: "Fix Platform Errors",
          members: ["face-1", "face-2", "face-3"],
          budget: "Not Set",
          completion: 100
        },
        {
          name: "spotify",
          title: "Launch new Mobile App",
          members: ["face-1", "face-2"],
          budget: "$20,600",
          completion: 100
        },
        {
          name: "jira",
          title: "Add the New Landing Page",
          members: ["face-1", "face-2", "face-3"],
          budget: "$4,000",
          completion: 80
        },
        {
          name: "invision",
          title: "Redesign Online Store",
          members: ["face-1", "face-2", "face-4"],
          budget: "$2,000",
          completion: "Cancelled"
        }
      ]
    };
  },
  methods: {
    filter(filterName: string) {
      this.currentFilter = filterName;
    },
    getCompletionColor(completion: string | number) {
      let color = "#47B981";

      if (typeof completion === "string") {
        color = "#EF4444";
      } else if (completion != 100) {
        color = `linear-gradient(84deg, rgba(36,95,193,1) ${completion}%, rgba(255,255,255,1) 0%)`;
      }
      return {
        background: color
      };
    }
  }
});
</script>

<style lang="scss">
.project-section {
  min-width: 37em;
}
.activeTabBtn {
  border-color: #1890ff;
  color: #1890ff;
  transition: all 0.3s;
}

.company-title i {
  width: 25px;
  height: 25px;
}
</style>
